##
This file is part of decoding
Copyright (C) 2012  Guillaume Quintin, INRIA

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License along
with this program; if not, write to the Free Software Foundation, Inc.,
51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
##

==OVERVIEW==

`decoding` provides some finite fields and finite rings. However
these implementations are not optimized. For efficiency it is
strongly recommanded to use external library like GMP or MPFQ.
To implement your own finite fields or rings or to wrap external
libraries see `decoding-rings`(3).

==DESCRIPTION==

The following finite fields and rings are provided by `decoding`.
If the wanted ring is implemented by `decoding/rings/wanted_ring.c`
you must do

``
#include <decoding/rings/wanted_ring.c>
#include <decoding/algos.c>
``

to use it. All the proposed rings are in the `include/decoding/rings`
directory. If you do not provide any name for your ring, one will
be set by default. It is recommended to use a name with the
`RING_NAME` macro.

``
#define RING_NAME myring
#include <decoding/rings/wanted_ring.c>
#include <decoding/algos.c>
``

===LIST OF FINITE RINGS===

> `GF5.c`
  Implements GF(5). It is an example of implementation of a finite
  field and contains the documentation on the making of finite rings
  for `decoding`. See `decoding-rings`(3) for details.

