/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

void ll_get_mask_1(mp_limb_t *r,int bits) {
  if ( bits == sizeof(mp_limb_t) * 8 ) {
    r[0] = ((mp_limb_t)-1) & GMP_NUMB_MASK;
  }
  else {
    r[0] = (((mp_limb_t)1 << bits) - 1) & GMP_NUMB_MASK;
  }
}

void ll_get_mask_n(mp_limb_t *r,int bits) {
  int off,sh,n;
  mp_limb_t *tmp;
  off = bits / GMP_NUMB_BITS;
  sh = bits % GMP_NUMB_BITS;
  n = off + 1;
  tmp = ll_calloc(n * sizeof(mp_limb_t));
  tmp[off] = 1 << sh;
  mpn_sub_1(r,tmp,n,(mp_limb_t)1);
  ll_free(tmp);
}

void ll_mpn_and_n(mp_limb_t *r,mp_limb_t *mask,int n) {
  int i;
  for( i = 0 ; i < n ; i++ ) {
    r[i] &= mask[i];
  }
}

