/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
*/

void ll_binomial(R r,int n,int k) {
#ifdef RING_COMM_CAR2
  unsigned int un,uk,bin;
  un = (unsigned int)n;
  uk = (unsigned int)k;
  /* Intellectual masturbation: fucking useless !!!!!
     A simple ``if" is sufficient !!!!! */
  bin = (un | (~uk)) + 1;
  bin = ~((-bin) | bin);
  bin >>= ((sizeof(unsigned int) * 8) - 1);
  R_castint(r,(int)bin);
#else
#ifdef CHARACTERISTIC_WORD
  switch(k) {
    case 1:
      R_castint(r,n);
      break;
    default: {
      unsigned long un,uk,bin;
      mpz_t tmp;
      un = (unsigned long)n;
      uk = (unsigned long)k;
      mpz_init(tmp);
      mpz_bin_uiui(tmp,un,uk);
      bin = mpz_fdiv_ui(tmp,(unsigned long)R_characteristic);
      R_cast_integer(r,(R_characteristic_type)bin);
      mpz_clear(tmp);
      break;
    }
  }
#else
  (void)r;
  (void)n;
  (void)k;
#endif
#endif
}

