/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_dbpol_discrepancy(R r,R *a,int nax,int nay,\
int mx,int my,R x,R y);`
  Set `r` to be the evaluation at (`x`,`y`) of the
  (`mx`,`my`)-Hasse derivative of `a` of size (`nax`,`nay`).
*/

void ll_dbpol_discrepancy(R r,R *a,int nax,int nay,int mx,int my,R x,R y) {
  int i;
  R *tmp;
  tmp = ll_vec_malloc_init(nay);
  for( i = my ; i < nay ; i++ ) {
    ll_upol_discrepancy(tmp[i],&a[i * nax],nax,mx,x);
  }
  ll_upol_discrepancy(r,tmp,nay,my,y);
  ll_vec_free(tmp,nay);
}

