/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_upol_discrepancy(R r,R *a,int na,int m,R x);`
  Set `r` to be the evaluation at `x` of the `m`-th Hasse
  derivative of `a` with size `na`.
*/

void ll_upol_discrepancy(R r,R *a,int na,int m,R x) {
  int i;
  R bin;
  R_init(bin);
  ll_binomial(bin,na - 1,m);
  R_mul(r,bin,a[na - 1]);
  for( i = na - 2 ; i >= m ; i-- ) {
    ll_binomial(bin,i,m);
    R_mul(bin,bin,a[i]);
    R_mul(r,r,x);
    R_add(r,r,bin);
  }
  R_clear(bin);
}

