/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

/**
> `void ll_upol_roots(R *r,int *nr,R *a,int na);`
  Set `r` of size `nr` to be the vector constituted by the roots
  of `a` of size `na`. By default no algorithm is provided and
  the function will terminate your program. Usually the ring
  provides its own root finding function, see
  `decoding-alphabets`(3) for details.
  You can provide your own root finding function with
  `MY_UPOL_ROOTS`, see `decoding-defines`(3) for details.
*/

void ll_upol_roots(R *r,int *nr,R *a,int na) {
#ifdef MY_UPOL_ROOTS
  MY_UPOL_ROOTS(r,nr,a,na);
#else
  (void)r;
  (void)nr;
  (void)a;
  (void)na;
  ll_die("ll_upol_roots() not implemeted\n"
         "provide your own.");
#endif
}

