/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#define _POSIX_C_SOURCE 1

#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include <stdarg.h>
#include <decoding/decoding.h>

#define RING_NAME fld
#define PRIME 23
#include <decoding/rings/gfp_word.c>
#include <decoding/algos.c>

int main(void) {
  fld m[6],tm[6];
  int i;

  srand(time(0));
  fld_ring_init();
  for( i = 0 ; i < 6 ; i++ ) {
    fld_castint(m[i],i);
  }
  fld_ll_mat_transpose(tm,m,2,3);
  fld_ll_print(stdout,"m =\n%m\n\ntm =\n%m\n\n",m,2,3,tm,3,2);
  return 0;
}

