/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#define _POSIX_C_SOURCE 1

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <decoding/decoding.h>

#define RING_NAME rng
#define PRIME 67
#include <decoding/rings/gfp_word.c>
#include <decoding/algos.c>

#define N 100000000

int main(int argc,char **argv) {
  int i,n;
  rng *a,*b,c;
  if ( argc != 2 ) return -1;
  srand(time(0));
  rng_ring_init();
  a = rng_ll_vec_malloc_random(N);
  b = rng_ll_vec_malloc_random(N);
  rng_init(c);
  rng_random(c);
  n = atoi(argv[1]);
  for( i = 0 ; i < n ; i++ ) {
    rng_add(a[i],b[i],c);
  }
  return 0;
}

