/*
 * This file is part of decoding
 * Copyright 2012  Guillaume Quintin, INRIA
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
 */

#define _POSIX_C_SOURCE 1

#include <time.h>
#include <stdio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <decoding/decoding.h>

#define RING_NAME fld
#define DEGREE 7
#include <decoding/rings/mpfq_gf2n_wrapper.c>
/*
#define PRIME 67
#include <decoding/rings/gfp_word.c>
*/
#include <decoding/algos.c>

void test_hamming(int n) {
  int i,w;
  fld_vec v;
  w = n / 2;
  fld_vec_init(v);
  for ( i = 0 ; i < n ; i++ ) {
    fld_vec_random_hamming_weight(v,n,w);
    if ( fld_vec_hamming_weight(v) != w ) {
      fprintf(stderr,"Error\n");
      exit(-1);
    }
  }
  fld_vec_clear(v);
  printf("OK\n");
}

int main(void) {
  ll_random_seed(time(0));
  fld_ring_init();
  test_hamming(10000);
  return 0;
}

